#include<stdio.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<netdb.h>
#include<string.h>


//puerto al que nos comunicamos 80dec = 50hex
#define PORT        0x50

//dominio direccion del pc de cdmon
#define HOST        "dinamico.cdmon.org"

#define BUFFERSIZE     8192
 

//funcion para pasar a minuscula caracteres
#ifndef strlwr
#ifndef _strlwr
char* strlwr(char *s){
	char *p;
	for(p=s;*p!='\0';p++){
		*p=tolower(*p);
	};
	return s;
};
#endif
#endif

int	show_help();
int update_now(char*,char*,int);

int main(int argc, char *argv[]){
		
	//START VARIABLES	Iniciamos las variables.
	int 	i = 0;		//indice
	char	str_user[200];	//nombre usuario
	char	str_key[200];	//contrasea encriptada en md5
	
	int	gtn_user = 0;	//hay que juntar el nombre de usuario
	int	gtn_key = 0;	//hay que juntar la contrasea por que tiene espacios
	int	silent_mode = 0;	//modo silencioso

	str_user[0] = 0;
	str_key[0] = 0;
		
	//NO ARGUMENTS SHOW HELP	Sin argumentos muestra la ayuda.
	if(argc == 1) return show_help();
	
	
	//VERIFI ARGUMENTS	Verificar argumentos.
	for(i=1;i<argc;i++){		
		if(strcmp(argv[i],"-u") == 0 || strcmp(argv[i],"-U") == 0){
			gtn_key = 0;		
			gtn_user = 1;

		//SHOW HELP		Muestra la ayuda si se especifico parametro -h
		}else if(strcmp(argv[i],"-h") == 0 || strcmp(argv[i],"-H") == 0){
			return show_help();			

		//MD5 KEY	Contrasea de usuario codificada en MD5
		}else if(strcmp(argv[i],"-p") == 0 || strcmp(argv[i],"-P") == 0){
			
			gtn_user = 0;
			gtn_key = 1;
		//SILENT MODE	Modo silencioso, no muestra nada por pantalla.
		}else if(strcmp(argv[i],"-s") == 0 || strcmp(argv[i],"-S") == 0){
			
			silent_mode = 1;
			gtn_key = 0;
			gtn_user = 0;
			
		//OTER IS KEY OR USER	Colecciona los argumentos.
		}else{			
			//GETTING USER	Coleccionamos el nombre de usuario.
			if (gtn_user){
				if(strlen(str_user)>0){
					strcat(str_user," ");
					strcat(str_user,argv[i]);
				}else{
					strcpy(str_user,argv[i]);
				};
	
			//GETTING KEY	Coleccionamos la contrasea MD5.
			}else if(gtn_key){
				if(strlen(str_key)>0){
					strcat(str_key," ");
					strcat(str_key,argv[i]);
				}else{
					strcpy(str_key,argv[i]);
				};
			};
		};
	};

	//NO USER OR KEY	No se especifico el usuario o la contrasea
	if(	strlen(str_user)== 0 ||	strlen(str_key)== 0 ) return show_help();
	
	if( silent_mode == 0){
		printf("\r\n");
		printf("USER: %s\r\n",str_user);
		printf("MD5 PASS: %s\r\n",str_key);
	};
	return update_now(str_user,strlwr(str_key),silent_mode);
};


int	show_help(){
	
	printf("\r\n");
	printf("CDMON UPDATER v 1.0\r\n");
	printf("By: Soft 5VZ\r\n");
	printf("web: www.soft5vz.com.ar\r\n");
	printf("\r\n");
	printf("USAGE:\t cdmonup [-h] [-s] [-u user_name] [-p md5_key]\r\n");
	printf("\r\n");
	printf("OPTIONS:\r\n");
	printf("\t-h\t\tShow this help.\r\n");
	printf("\t-s\t\tSilent mode. It does not show any exit.\r\n");
	printf("\t-u user_name\tIndicate account user name.\r\n");
	printf("\t-p md5_key\tMD5 encripted password.\r\n");
	printf("\tnone\t\tShow this help.\r\n");
	printf("\r\n");
		
    return 0;
};

int update_now(char *str_user,char *str_key,int silent_mode){
    char				host_name[100];
	char		    	buffer[BUFFERSIZE];
	int					sck_main;	
	struct sockaddr_in	saddr_in;
	struct hostent		*hstnt;
	char mensage[] = "GET /onlineService.php?enctype=MD5&n=%s&p=%s HTTP/1.0\r\nHost: %s\r\nUser-Agent: HTTPTool/1.0\r\n\r\n";


	//direccion
	strcpy(host_name,HOST);

	//condiguiendo la ip de la maquina remota
	if ((hstnt = gethostbyname(host_name)) == 0) {
		if(silent_mode == 0)printf("ERROR: Getting remote HOST %s.\r\n",host_name);
		return 1;
	};

	//establecemos los parametros de la estructura para conectar
	memset(&saddr_in, 0, sizeof(saddr_in));
	saddr_in.sin_family = AF_INET;
	saddr_in.sin_addr.s_addr = ((struct in_addr *)(hstnt->h_addr))->s_addr;
	saddr_in.sin_port = htons(PORT);

	//creamos un socket para conectar
	if ((sck_main = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		if(silent_mode == 0)printf("ERROR: Creating socket.\r\n");
		return 1;
	};

	//establecemos la coneccion
	if (connect(sck_main,(struct sockaddr *)  &saddr_in, sizeof(saddr_in)) == -1) {
		if(silent_mode == 0)printf("ERROR: Connecting remote HOST.\r\n");
		return 1;
	};

	//enviamos el mensaje
	sprintf(buffer,mensage,str_user,str_key,HOST);
	
	if (send(sck_main, buffer, strlen(buffer), 0) == -1) {
		if(silent_mode == 0)printf("ERROR: Can't send data.\r\n");
		return 1;
	};

	//esperamos respuesta
     if (recv(sck_main, buffer, BUFFERSIZE, 0) == -1){
		if(silent_mode == 0)printf("ERROR: Getting data.\r\n");
		return 1;
    };

	//imprimimos salida resultado
	if(silent_mode == 0){
		char *p = strstr(buffer,"&");
		printf("Server Responce: %s\r\n", p);
			
		if(strstr(buffer,"errorlogin") != 0){
			printf("Error: Incorrect user or password.\r\n");
		};
		if(strstr(buffer,"guardatok") != 0){
			printf("Result: Update IP ...OK.\r\n");
		};
		printf("\r\n");
	};

	close(sck_main);
	return 0;
};
